module Day3.Shared (
   Contents,
   Item,
   itemPriority,
   priority,
   maybeSum
   )
 where
import qualified Data.Map as Map

type Contents = String
type Item = Char



itemPriority :: Item -> Maybe Int
itemPriority = flip Map.lookup itemMap
  where
  itemMap = Map.fromList $ (['a' .. 'z'] ++ ['A' .. 'Z']) `zip` [1 .. 52]

addMaybe :: Int -> Maybe Int -> Int
addMaybe acc Nothing = acc
addMaybe acc (Just y) = acc + y

maybeSum :: [Maybe Int] -> Int
maybeSum = foldl addMaybe 0

priority :: Contents -> Int
priority cs = maybeSum prioList
  where
    prioList = map itemPriority cs
